/*
 * include/keymaps.h - This file contains prototypes for all
 *                     implemented keyboard-layouts.
 */

#ifndef KEYMAPS_H
#define KEYMAPS_H

/* Keyboard-Layout for the alphanumeric part of the keyboard */

extern unsigned char key_map_finnish[];
extern unsigned char shift_map_finnish[];
extern unsigned char alt_map_finnish[];

extern unsigned char key_map_finnish_latin1[];
extern unsigned char shift_map_finnish_latin1[];
extern unsigned char alt_map_finnish_latin1[];

extern unsigned char key_map_us[];
extern unsigned char shift_map_us[];
extern unsigned char alt_map_us[];

extern unsigned char key_map_uk[];
extern unsigned char shift_map_uk[];
extern unsigned char alt_map_uk[];

extern unsigned char key_map_gr[];
extern unsigned char shift_map_gr[];
extern unsigned char alt_map_gr[];

extern unsigned char key_map_gr_latin1[];
extern unsigned char shift_map_gr_latin1[];
extern unsigned char alt_map_gr_latin1[];

extern unsigned char key_map_fr[];
extern unsigned char shift_map_fr[];
extern unsigned char alt_map_fr[];

extern unsigned char key_map_fr_latin1[];
extern unsigned char shift_map_fr_latin1[];
extern unsigned char alt_map_fr_latin1[];

extern unsigned char key_map_dk[];
extern unsigned char shift_map_dk[];
extern unsigned char alt_map_dk[];

extern unsigned char key_map_dk_latin1[];
extern unsigned char shift_map_dk_latin1[];
extern unsigned char alt_map_dk_latin1[];

extern unsigned char key_map_dvorak[];
extern unsigned char shift_map_dvorak[];
extern unsigned char alt_map_dvorak[];

extern unsigned char key_map_sg[];
extern unsigned char shift_map_sg[];
extern unsigned char alt_map_sg[];

extern unsigned char key_map_sg_latin1[];
extern unsigned char shift_map_sg_latin1[];
extern unsigned char alt_map_sg_latin1[];

extern unsigned char key_map_no[];
extern unsigned char shift_map_no[];
extern unsigned char alt_map_no[];

extern unsigned char key_map_sf[];
extern unsigned char shift_map_sf[];
extern unsigned char alt_map_sf[];

extern unsigned char key_map_sf_latin1[];
extern unsigned char shift_map_sf_latin1[];
extern unsigned char alt_map_sf_latin1[];

extern unsigned char key_map_es[]; 
extern unsigned char shift_map_es[]; 
extern unsigned char alt_map_es[]; 

extern unsigned char key_map_es_latin1[]; 
extern unsigned char shift_map_es_latin1[]; 
extern unsigned char alt_map_es_latin1[]; 

extern unsigned char key_map_be[];
extern unsigned char shift_map_be[];
extern unsigned char alt_map_be[];

/* Keyboard-Layout for the numeric part of the keyboard */

extern unsigned char num_table_comma[];
extern unsigned char num_table_dot[];

#endif
/* End of include/keymaps.h */
